//+------------------------------------------------------------------+
//| Stoch_Env.mq4.mq4
//| NoName (and-)
//| http://www.tradersforum.net.ru/forum/
//+------------------------------------------------------------------+
#property copyright "NoName"
#property link      "http://www.tradersforum.net.ru/forum"

//********* input parameters ****************
extern int     KPer15      =14;
extern int     KPer30      =14;
extern int     KPer60      =14;
//----------------------------------
extern int     EnvPer15       =25;
extern int     EnvPer30       =25;
extern int     EnvPer60       =25;
//----------------------------------
extern double  EnvDev15       =20;
extern double  EnvDev30       =20;
extern double  EnvDev60       =20;
//----------------------------------
extern int     EnvShift       =1;
//----------------------------------
extern int     TP             =20;
extern int     SL             =20;
extern double  Lot            =1;
extern int     Slippage       =3;
//*******************************************

int   up_lim  =75;     // 
int   low_lim =25;     // 
//-------------------------------------------
int ticket;

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//-------------------------------
if (EnvDev15==0) EnvDev15=0.1;
if (EnvDev30==0) EnvDev30=0.1;
if (EnvDev60==0) EnvDev60=0.1;
//-------------------------------
int Spread=MarketInfo(Symbol(), MODE_SPREAD);
if (Spread>=SL)
  {
  SL=Spread+1;
  Print ("StopLoss    Spread,   SL=", SL);
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//*********************************************************************
double Stoch_array15[49];
double Stoch_array30[49];
double Stoch_array60[49];
//------   RSI-----------------
int    i=0;
while (i<50)
 {
Stoch_array15[i]= iStochastic(NULL, 15, KPer15, 3, 3, MODE_SMA ,0, 0, i) ;
Stoch_array30[i]= iStochastic(NULL, 30, KPer15, 3, 3, MODE_SMA ,0, 0, i) ;
Stoch_array60[i]= iStochastic(NULL, 60, KPer15, 3, 3, MODE_SMA ,0, 0, i) ;
i++;
 }
//------------------------------------------------------
ArraySetAsSeries(Stoch_array15,true);
ArraySetAsSeries(Stoch_array30,true);
ArraySetAsSeries(Stoch_array60,true);
//-------------- M15 ---------------------------------------------------------------------
double
EnLow15_0=iEnvelopesOnArray(Stoch_array15,0,EnvPer15,0,EnvShift,EnvDev15,MODE_LOWER,0);

double
EnUp15_0=iEnvelopesOnArray(Stoch_array15,0,EnvPer15,0,EnvShift,EnvDev15,MODE_UPPER,0);

double Stoch_M15_0=iStochastic(NULL, 15, KPer15, 3, 3, MODE_SMA ,0, 0, 0);
double Stoch_M15_1=iStochastic(NULL, 15, KPer15, 3, 3, MODE_SMA ,0, 0, 1);
//-------------- M30 ---------------------------------------------------------------------
double
EnLow30_0=iEnvelopesOnArray(Stoch_array30,0,EnvPer30,0,EnvShift,EnvDev30,MODE_LOWER,0);

double
EnUp30_0=iEnvelopesOnArray(Stoch_array30,0,EnvPer30,0,EnvShift,EnvDev30,MODE_UPPER,0);

double Stoch_M30_0=iStochastic(NULL, 30, KPer30, 3, 3, MODE_SMA ,0, 0, 0);
double Stoch_M30_1=iStochastic(NULL, 30, KPer30, 3, 3, MODE_SMA ,0, 0, 1);
//--------------- H1 --------------------------------------------------------------------
double
EnLow60_0=iEnvelopesOnArray(Stoch_array60,0,EnvPer60,0,EnvShift,EnvDev60,MODE_LOWER,0);

double
EnUp60_0=iEnvelopesOnArray(Stoch_array60,0,EnvPer60,0,EnvShift,EnvDev60,MODE_UPPER,0);

double Stoch_M60_0=iStochastic(NULL, 60, KPer60, 3, 3, MODE_SMA ,0, 0, 0);
double Stoch_M60_1=iStochastic(NULL, 60, KPer60, 3, 3, MODE_SMA ,0, 0, 1);

//=====      =========================================================
int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  {  
//---------   ----------------------------
  if   ( Stoch_M15_1 < EnLow15_0  &&
         Stoch_M15_0 > EnLow15_0  &&
         Stoch_M30_1 < EnLow30_0  &&
         Stoch_M30_0 > EnLow30_0  &&
         Stoch_M60_1 < EnLow60_0  &&
         Stoch_M60_0 > EnLow60_0  )
   {
   Buy();
   return(0);        
   }
//--------   ------------------------------
  if   ( Stoch_M15_1 > EnUp15_0  &&
         Stoch_M15_0 < EnUp15_0  &&
         Stoch_M30_1 > EnUp30_0  &&
         Stoch_M30_0 < EnUp30_0  &&
         Stoch_M60_1 > EnUp60_0  &&
         Stoch_M60_0 < EnUp60_0  )
   {       
   Sell();
   return(0);          
   } 
//------------------------------------------------------------------
  }
//===============================================================================================
if (Orders>0) 
  {
  if (OrderSelect(ticket, SELECT_BY_TICKET)==false)
    {
    Print (" OrderSelect #", GetLastError()); 
    return(0); 
    } 
    if ((CurentProfit() ==  TP)  ||
        (CurentProfit() == -SL))
       
       CloseOrder();
  }
//-------------------------------------------------------------------+
   return(0);
  }     //start() - end
//+------------------------------------------------------------------+
//****************************************************************************************
void Buy()
{
ticket=OrderSend(Symbol(),0,Lot,Ask,Slippage,0,0,NULL,0,0,CLR_NONE);
if (ticket<0) {Print("   Buy #", GetLastError()); return(0);} 
}
//****************************************************************************************
void Sell()
{
ticket=OrderSend(Symbol(),1,Lot,Bid,Slippage,0,0,NULL,0,0,CLR_NONE);
if (ticket<0) {Print("   Buy #", GetLastError()); return(0);} 
}
//****************************************************************************************
int CurentProfit()
{
if (OrderType()==OP_BUY)
return( (Bid-OrderOpenPrice()) / Point);
if (OrderType()==OP_SELL)
return( (OrderOpenPrice()-Ask) / Point);
}
//****************************************************************************************
void CloseOrder ()
{
if (OrderType()==OP_BUY)
  {
  if (OrderClose(ticket, Lot, Bid, Slippage, CLR_NONE)==false)
  { Print(" BuyOrderClose #", GetLastError()); return(0);}
  }
if (OrderType()==OP_SELL)
  {
  if (OrderClose(ticket, Lot, Ask, Slippage, CLR_NONE)==false)
  { Print(" BuyOrderClose #", GetLastError()); return(0);}
  }
}
//***************************************************************************************